#include "darcdc.h"
//#include "../../../projectdc/jpeg-src/jpeg-6b/jpeglib.h"
#include <jpeglib.h>

uint8 __movstr_i4_odd;

uint32 disc_txr;
void disc_display(float fade) {
	vertex_ot_t	v;
	poly_hdr_t	hdr;

	if (fade < 0.0f) fade = 0.0f;

        ta->poly_hdr_txr(&hdr, TA_OPAQUE, TA_RGB565, 1024, 512, disc_txr, TA_NO_FILTER);
        ta->commit_poly_hdr(&hdr);

	/* - -
	   + - */
	v.flags = TA_VERTEX_NORMAL;
        v.x = 0.0f;
        v.y = 512.0f;
	v.z = 1.0f;
        v.u = 0.0f; v.v = 1.0f;
        v.a = 1.0f; v.r = v.g = v.b = fade;
	v.oa = v.or = v.og = v.ob = 0.0f;
        ta->commit_vertex(&v, sizeof(v));

	/* + -
	   - - */
	v.y = 0.0f;
	v.v = 0.0f;
        ta->commit_vertex(&v, sizeof(v));

	/* - -
	   - + */
        v.x = 1024.0f;
        v.y = 512.0f;
        v.u = 1.0f; v.v = 1.0f;
        ta->commit_vertex(&v, sizeof(v));

	/* - +
	   - - */
	v.flags = TA_VERTEX_EOL;
        v.y = 0.0f; v.v = 0.0f;
        ta->commit_vertex(&v, sizeof(v));
}

void disc_blank() {
	poly_hdr_t	hdr;

        ta->poly_hdr_col(&hdr, TA_TRANSLUCENT);
        ta->commit_poly_hdr(&hdr);
}

int jjpeg_to_texture(char * filename, unsigned short *tex, int n, int scale);

void intro() {
        int x,y;
	float f;
        uint16 *txrtmp;

        disc_txr = ta->txr_allocate(1024*512*2);
        txrtmp = (uint16*)ta->txr_map(disc_txr);

        jjpeg_to_texture("/rd/bg.jpg", txrtmp, 1024, 1);

	for (f=0.0f; f<1.0f; f+=0.01f) {
                ta->begin_render();
		disc_display(f);
                ta->commit_eol();
		disc_blank();
                ta->commit_eol();
                ta->finish_frame();
	}
	for (f=0.0f; f<360.0f; f+=1.0f) {
                ta->begin_render();
		disc_display(1.0f);
                ta->commit_eol();
		disc_blank();
                ta->commit_eol();
                ta->finish_frame();
	}
	for (f=1.0f; f>=-0.03f; f-=0.01f) {
                ta->begin_render();
		disc_display(f);
                ta->commit_eol();
		disc_blank();
                ta->commit_eol();
                ta->finish_frame();
	}

        for(x = 0; x < 1024; x++)
                for(y = 0; y < 512; y++)
                        txrtmp[1024*y + x] = ((0 >> 3) << 11)| ((0 >> 2) << 5)| ((0 >> 3) << 0);

        ta->txr_release_all();
}


int jjpeg_to_texture(char * filename, unsigned short *tex, int n, int scale)
{
    int i;
    unsigned short *ourbuffer;

    /* This struct contains the JPEG decompression parameters and pointers to
     * working space (which is allocated as needed by the JPEG library).
     */
    struct jpeg_decompress_struct cinfo;
    
    struct jpeg_error_mgr jerr;
    
    /* More stuff */
    //FILE * infile;                /* source file */
    int infile;                /* source file */
    JSAMPARRAY buffer;            /* Output row buffer */
    int row_stride;               /* physical row width in output buffer */
    
    ourbuffer = (unsigned short *)malloc(sizeof(unsigned short)*n);

    /* In this example we want to open the input file before doing anything else,
     * so that the setjmp() error recovery below can assume the file is open.
     * VERY IMPORTANT: use "b" option to fopen() if you are on a machine that
     * requires it in order to read binary files.
     */
        
    if ((infile = fs->open(filename, O_RDONLY)) == 0) {
        printf("can't open %s\r\n",filename);
	return 0;
    }
    
    /* Step 1: allocate and initialize JPEG decompression object */
    
    /* We set up the normal JPEG error routines */
    cinfo.err = jpeg_std_error(&jerr);
    
    /* Now we can initialize the JPEG decompression object. */
    jpeg_create_decompress(&cinfo);
    
    /* Step 2: specify data source (eg, a file) */
    
    jpeg_stdio_src(&cinfo, infile);
    
    /* Step 3: read file parameters with jpeg_read_header() */
    
    (void) jpeg_read_header(&cinfo, TRUE);
    /* We can ignore the return value from jpeg_read_header since
     *   (a) suspension is not possible with the stdio data source, and
     *   (b) we passed TRUE to reject a tables-only JPEG file as an error.
     * See libjpeg.doc for more info.
     */
    
    /* Step 4: set parameters for decompression */
    
    cinfo.scale_denom = scale; /* must be 1, 2, 4, or 8 */

    /* Step 5: Start decompressor */
    
    (void) jpeg_start_decompress(&cinfo);
    /* We can ignore the return value since suspension is not possible
     * with the stdio data source.
     */
    
    /* We may need to do some setup of our own at this point before reading
     * the data.  After jpeg_start_decompress() we have the correct scaled
     * output image dimensions available, as well as the output colormap
     * if we asked for color quantization.
     * In this example, we need to make an output work buffer of the right size.
     */ 
    /* JSAMPLEs per row in output buffer */
    row_stride = cinfo.output_width * cinfo.output_components;
    /* Make a one-row-high sample array that will go away when done with image */
    buffer = (*cinfo.mem->alloc_sarray)
	((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);
    
    /* Step 6: while (scan lines remain to be read) */
    /*           jpeg_read_scanlines(...); */
    
    /* Here we use the library's state variable cinfo.output_scanline as the
     * loop counter, so that we don't have to keep track ourselves.
     */
    while (cinfo.output_scanline < cinfo.output_height) {
	/* jpeg_read_scanlines expects an array of pointers to scanlines.
	 * Here the array is only one element long, but you could ask for
	 * more than one scanline at a time if that's more convenient.
	 */
	(void) jpeg_read_scanlines(&cinfo, buffer, 1);

	for(i=0; i<row_stride/3; i++)
	    ourbuffer[i] = ((buffer[0][i*3]>>3)<<11) + ((buffer[0][i*3+1]>>2)<<5) + (buffer[0][i*3+2]>>3);
	
	memcpy(tex + n*(cinfo.output_scanline-1), ourbuffer, 2*row_stride/3); 
    }
    
    /* Step 7: Finish decompression */
    
    (void) jpeg_finish_decompress(&cinfo);
    /* We can ignore the return value since suspension is not possible
     * with the stdio data source.
     */
    
    /* Step 8: Release JPEG decompression object */
    
    /* This is an important step since it will release a good deal of memory. */
    jpeg_destroy_decompress(&cinfo);
    
    /* After finish_decompress, we can close the input file.
     * Here we postpone it until after no more JPEG errors are possible,
     * so as to simplify the setjmp error logic above.  (Actually, I don't
     * think that jpeg_destroy can do an error exit, but why assume anything...)
     */
    fs->close(infile);
    
    /* At this point you may want to check to see whether any corrupt-data
     * warnings occurred (test whether jerr.pub.num_warnings is nonzero).
     */

    free(ourbuffer);
    
    /* And we're done! */
    return 1;
}

#include <string.h>

/*
 * Compare strings.
 */
int
strcmp(s1, s2)
	register const char *s1, *s2;
{
	while (*s1 == *s2++)
		if (*s1++ == 0)
			return (0);
	return (*(const unsigned char *)s1 - *(const unsigned char *)(s2 - 1));
}

char *
strcat(s, append)
	register char *s;
	register const char *append;
{
	char *save = s;

	for (; *s; ++s);
	while ((*s++ = *append++));
	return(save);
}

